/*
 * ex13_3d.cu
 * This is an exercise for learning to write a kernel function.
 */

#include <stdio.h>

__global__ void cudaHello()
{
  printf( "Hello from thread {%d, %d, %d} block {%d, %d, %d} %d\n", threadIdx.x, threadIdx.y, threadIdx.z, blockIdx.x, blockIdx.y, blockIdx.z, blockDim.x );
}

int main(int argc, char *argv[])
{
  /* Some examples might use the word dimBlock */
  dim3 threads(1, 3, 2);
  /* Some examples might use the word dimGrid */
  dim3 blocks(2, 3); /* Will default to dim3 blocks(2, 3, 1) */

  cudaHello<<< blocks, threads >>>();

  cudaDeviceReset();

  return 0;
}
