/*
 * ex14.cu
 * This is an exercise that aim to revise what you have learnt in previous exercises.
 */
#include <stdio.h>

void vector_add_cpu(const int *arr1, const int *arr2, int *results, int arrSize);
void verify_results(const int *resultsFromCPU, const int *resultsFromGPU, int arrSize);

__global__ void vector_add_kernel()
{
}

int main()
{
  int i;
  int arrSize = 256;

  int *arr1, *arr2;
  int *resultsFromCPU;

  int *cudaArr1, *cudaArr2;
  int *cudaResults;
  int *resultsFromGPU;

  /* Allocate CPU memory */
  arr1 = (int *)malloc( arrSize * sizeof(int) );
  arr2 = (int *)malloc( arrSize * sizeof(int) );
  resultsFromCPU = (int *)malloc( arrSize * sizeof(int) );
  resultsFromGPU = (int *)malloc( arrSize * sizeof(int) );

  /* Initialize vectors */
  for( i = 0; i < arrSize; i++ )
  {
    arr1[i] = (int) (i * 2);
    arr2[i] = (int) ((i * 2) + 1);
  }

  vector_add_cpu(arr1, arr2, resultsFromCPU, arrSize);

  /********************************************************/
  /* Write your implementation below */
  /********************************************************/





  /* End */

  verify_results(resultsFromCPU, resultsFromGPU, arrSize);
  
  free(arr1);
  free(arr2);
  free(resultsFromCPU);
  free(resultsFromGPU);

  return 0;
}

/* CPU implementation of vector addition */
void vector_add_cpu(const int *arr1, const int *arr2, int *resultsFromCPU, int arrSize)
{
  int i;
  for( i = 0; i < arrSize; i++ )
    resultsFromCPU[i] = arr1[i] + arr2[i];
}

void verify_results(const int *resultsFromCPU, const int *resultsFromGPU, int arrSize)
{
  int i;

  for( i = 0; i < arrSize; i++ )
  {
    /* printf statement, uncomment it for debugging purpose */
    // printf( "%d - CPU: %d, GPU: %d\n", resultsFromCPU[i], resultsFromGPU[i] );
    if( resultsFromCPU[i] != resultsFromGPU[i] )
    {
      printf( "Sorry, wrong answers, try again.\n" );
      exit(EXIT_FAILURE);
    }
  }
  
  printf( "Congratulations, you got it!\n" );
}
