/*
  ex23.cu
  This is an exercise for learning the usage of atomic functions.
*/
#include <stdio.h>

__global__ void simple_add_kernel(int *a)
{
  //atomicAdd( a, 2 );
  a[0] = a[0] + 2;
  printf( "In thread {%d %d}, block {%d %d}, a: %d\n", threadIdx.x, threadIdx.y, blockIdx.x, blockIdx.y, a[0] );
}

int main(int argc, char *argv[])
{
  int a;
  int *cudaA;

  cudaMalloc( (void **)&cudaA, sizeof(int) );
  cudaMemset( cudaA, 0, sizeof(int) );

  simple_add_kernel<<< 4, 4 >>>(cudaA);

  cudaMemcpy( &a, cudaA, sizeof(int), cudaMemcpyDeviceToHost );

  cudaFree(cudaA);

  printf( "Value of A: %d\n", a );

  cudaDeviceReset();

  return 0;
}
