#include <fftw3.h>
#include <complex.h>

extern void runFFTW(float *input, float complex *out, int size, int setup, int destroy);

void runFFTW(float *input, float complex *out, int size, int setup, int destroy)
{
  static fftwf_plan plan;

  if( setup )
    plan = fftwf_plan_dft_r2c_1d(size, input, (fftwf_complex *)out, FFTW_ESTIMATE);

  fftwf_execute(plan);

  if( destroy )
    fftwf_destroy_plan(plan);
}
