#include <mpi.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
  int ntasks, rank, len, rc;

  char hostname[MPI_MAX_PROCESSOR_NAME];

  rc = MPI_Init(&argc, &argv);

  if( rc != MPI_SUCCESS )
  {
    fprintf( stderr, "Error starting MPI program.\n" );
    MPI_Abort(MPI_COMM_WORLD, rc);
  }

  MPI_Comm_size(MPI_COMM_WORLD, &ntasks);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Get_processor_name(hostname, &len);

  printf( "Number of tasks: %d, rank: %d, Computer: %s\n", ntasks, rank, hostname );

  MPI_Finalize();

  return 0;
}
